/*
 * This file is part of Firestorm NIDS
 * Copyright (c) 2002,2003,2004 Gianni Tedesco <gianni@scaramanga.co.uk>
 * This program is released under the terms of the GNU GPL version 2
*/
#include "tcpip.h"

/* Mask to determine fragments */
unsigned short ipfmask=__constant_htons(IP_MF|IP_OFFMASK);

struct alert *cur_alert;
unsigned int alert_depth;
unsigned int cur_depth;

static void tcpip_fini(void)
{
	if ( use_ipfrag )
		ipfrag_free();
	if ( tcp_stateful )
		tcpstream_free();
}

struct proto_table firestorm_protocols[]={
	{.proto = &ipv4_p, .preq = ipv4_r},
	{.proto = &icmp_p, .preq = icmp_r},
	{.proto = &tcp_p, .preq = tcp_r},
	{.proto = &udp_p, .preq = udp_r},
	{.proto = NULL},
};

struct preproc firestorm_preprocs[]={
	{.name = "ipfrag", .init = ipfrag_init},
	{.name = "tcpstream", .init = tcpstream_init},
	{.name = NULL}
};

struct plugin_desc firestorm_plugin_desc = {
	.size		= sizeof(firestorm_plugin_desc),
	.name		= "decode.tcpip",
	.desc		= "The Internet Protocol Suite",
	.author_name	= "Gianni Tedesco",
	.author_email	= "gianni@scaramanga.co.uk",
	.ver_major	= 2,
	.ver_minor	= 0,
	.fini		= tcpip_fini,
};
