/*
 * This file is part of Firestorm NIDS
 * Copyright (c) 2004 Gianni Tedesco <gianni@scaramanga.co.uk>
 * This program is released under the terms of the GNU GPL version 2
*/
#ifndef __FIELD_HEADER_INCLUDED__
#define __FIELD_HEADER_INCLUDED__

struct field {
	const char *name;
	const char *desc;
	idx_type_t type;
	int ofs;

	union {
		int(*val)(struct packet *p, int l, idx_key_t *val);
		int(*str)(struct packet *p, int l, struct fvec *vec);
	}get;
	union {
		int(*val)(const char *, idx_key_t *val);
		int(*str)(const char *, struct fvec *vec);
	}parse;

	struct matcher *matcher;
	unsigned int cost;
	int allow_opts;
	const char *compatible;

	void *ornament;

	struct field *next;
};

struct field_reg {
	const char *proto;
	struct field *field;
};

typedef int (*field_cbfn_t)(struct field *, void *);

void field_add(struct proto *proto, struct field *f);
void field_load(void);
struct field *field_builtins(void);
struct field *field_find(const char *name);
struct field *field_foreach(field_cbfn_t cbfn, void *priv);

#endif /* __FIELD_HEADER_INCLUDED__ */
