/*
 * This file is part of Firestorm NIDS
 * Copyright (c) 2003,2004 Gianni Tedesco
 * Released under the terms of the GNU GPL version 2
*/
#ifndef __I_IDX_HEADER_INCLUDED__
#define __I_IDX_HEADER_INCLUDED__

struct i_fieldref {
	const char *name;
	struct i_type *type;
	struct i_fieldref *next;
};

struct i_type {
	int id;
	struct i_fieldref *(*new)(void);
	int (*insert)(struct i_fieldref *, idx_key_t, idx_val_t);
	int (*insert_str)(struct i_fieldref *, const char *, size_t, idx_val_t);
	int (*prepare)(struct i_fieldref *, idx_ofs_t *size,
			idx_ofs_t *keys, idx_ofs_t *vals);
	idx_ofs_t (*size)(struct i_fieldref *);
	idx_ofs_t (*keys)(struct i_fieldref *);
	idx_ofs_t (*vals)(struct i_fieldref *);
	int (*write)(struct i_fieldref *, struct fobuf *);
	void (*free)(struct i_fieldref *);
};

struct i_idx {
	idx_ofs_t num_fields;
	struct i_fieldref *fields;
};

struct i_idx *i_idx_new(void);
struct i_fieldref *i_idx_add_field(struct i_idx *idx, int type, const char *name);
int i_idx_write_fd(struct i_idx *idx, int fd);
void i_idx_free(struct i_idx *idx);

extern struct i_type idx_ordered_uint32 __private;
extern struct i_type idx_skunk __private;
extern struct i_type idx_skunk_nocase __private;

#endif /* __I_IDX_HEADER_INCLUDED__ */
