/*
 * This file is part of Firestorm NIDS
 * Copyright (c) 2002,2003,2004 Gianni Tedesco <gianni@scaramanga.co.uk>
 * This program is released under the terms of the GNU GPL version 2
*/
#ifndef __PREPROC_HEADER_INCLUDED__
#define __PREPROC_HEADER_INCLUDED__

/* We call this with the config args, and the plugin
 * adds a preprocessor function on to the active list */
typedef int (*proc_preproc_init)(const char *);

/* A preprocessor */
struct preproc {
	const char		*name;
	proc_preproc_init	init;
	struct preproc		*next;
};

void preproc_load(void);
int preproc_setup(const char *, const char *);
int preproc_activate(char *, notifier_t, notifier_dtor_t, void *);

void dispatch(struct packet *);

#endif /* __PREPROC_HEADER_INCLUDED__ */
