/******************************************************************************/
/* generic dataset routines                                                   */
/* (c) 2003 jamie twycross, milieu3@ukshells.co.uk                            */
/* released under gnu gpl version 2                                           */
/******************************************************************************/

#ifndef DATASET_H
#define DATASET_H

/* dataset structure */
typedef struct {
	unsigned int nvecs;  /* num of vectors in dataset */
	unsigned int ncomps;  /* dimension of vector */
	double **vec;  /* actual vectors */
	double **normvec;  /* normalised vectors */
	double *means, *sds;  /* means and standards deviations */
	unsigned int *order;  /* presentation order */
	double *dtmp;  /* working array of size nvecs */ 
} dataset_t;

/* function prototypes */
dataset_t *dataset_init(const unsigned int, const unsigned int);
void dataset_free(dataset_t *);
inline void dataset_addvec(dataset_t *, double *, const unsigned int);
inline void dataset_normalise(dataset_t *);
inline void dataset_normalise_vector(dataset_t *, double *, double *);
inline void dataset_permute(dataset_t *);
inline float *dataset_vtof(float *, double *, const unsigned int);

#endif
