/*
* This file is part of Firestorm NIDS
* Copyright (c) 2002,2003,2004 Gianni Tedesco
* This program is released under the terms of the GNU GPL version 2
*
* We support plugins for elog conversion purposes. Each target is an
* elog conversion target so we can convert to whatever...
*/
#include <firestorm.h>
#include <loader.h>
#include <alert.h>
#include <args.h>
#include <target.h>

struct target *targets;

/* Add a bunch of targets */
static void target_add(struct plugin *p, struct target *t)
{
	for(; t->name; t++) {
		t->next = targets;
		targets = t;
	}
}

/* Load all target plugins */
void target_load(void)
{
	loader_find_syms("firestorm_targets", (loader_cb_t)target_add);
}

/* Find a target by its name */
struct target *target_find(const char *name)
{
	struct target *ret;

	if ( name == NULL )
		name = "elog";

	for(ret=targets; ret; ret=ret->next)
	{
		if ( !strcmp(ret->name, name) )
			return ret;
	}
	return NULL;
}
